package dk.nsp.idsas.test.stepdefinitions;

import dk.nsp.test.idp.NspSoapClient;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.HelloRequest;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.apache.commons.io.IOUtils;
import org.apache.http.NoHttpResponseException;
import org.apache.log4j.Logger;

import javax.xml.bind.JAXBContext;
import javax.xml.ws.WebServiceException;
import java.io.StringWriter;
import java.net.URI;
import java.nio.charset.StandardCharsets;
import java.util.function.Consumer;

import static dk.nsp.test.idp.EmployeeIdentities.jordemoderAdaLovelace;

public class HelloSteps {

    private String result = "";

    @When("Jeg laver kaldet til hello service")
    public void jegLaverKaldetTilHelloService() {
        // Create the request
        HelloRequest request = new HelloRequest();
        request.setMyName("Babbage");

        // Call the service
        Logger log = Logger.getLogger(getClass());
        Consumer<String> nspSoapLogger = log::info;
        try (NspSoapClient c = new NspSoapClient(nspSoapLogger)) {
            URI uri = URI.create("http://localhost:8080/idsas/hello"); // TODO: hente endpoint fra properties i stedet
            String soapAction = "sayHello";
            NspSoapClient.NspSoapRequest nspSoapRequest = c.request(uri, soapAction).as(jordemoderAdaLovelace());

            // TODO: Skal flyttes ud i noget fælles test-klasse
            final StringWriter writer = new StringWriter();
            JAXBContext.newInstance(HelloRequest.class).createMarshaller().marshal(request, writer);
            String requestXml = writer.toString();

            System.out.println(requestXml);
            try (NspSoapClient.NspSoapResponse res = nspSoapRequest.execute(requestXml)) {
                result = IOUtils.toString(res.getResponse(), StandardCharsets.UTF_8);
            }
        } catch (NoHttpResponseException e) {
            throw new WebServiceException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    @Then("Jeg får et fornuftigt svar tilbage")
    public void jegFårEtFornuftigtSvarTilbage() {
        // TODO
        System.out.println(result);
    }

}
