package dk.nsp.idsas.ws;

import dk.sdsd.nsp.slalog.api.SLALogItem;
import dk.sdsd.nsp.slalog.ws.SLALoggingServletFilter;
import org.apache.log4j.Logger;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.servlet.ServletContext;
import javax.servlet.ServletRequest;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

import static dk.nsp.idsas.configuration.ServiceConfiguration.ANNOTATION_CONFIG_CONTEXT;

public abstract class AbstractWS {
	private static final Logger logger = Logger.getLogger(AbstractWS.class); // TODO: Delete this

	@Resource
	protected WebServiceContext context;

	@PostConstruct
	public void init() {
		logger.info("init");
		ServletContext servletContext = (ServletContext) context.getMessageContext().get(MessageContext.SERVLET_CONTEXT);
		Object o = servletContext.getAttribute(ANNOTATION_CONFIG_CONTEXT);
		((AnnotationConfigApplicationContext)o).getAutowireCapableBeanFactory().autowireBean(this);
	}

	protected SLALogItem getSlaLogItemFromContext() {
		ServletRequest servletRequest = (ServletRequest) context.getMessageContext().get(MessageContext.SERVLET_REQUEST);
		return (SLALogItem) servletRequest.getAttribute(SLALoggingServletFilter.CURRENT_LOGITEM_REQUEST_KEY);
	}

	// TODO: For testing purposes?
	public void setContext(WebServiceContext context) { this.context = context; }
}
