package dk.nsp.idsas.ws;

import dk.nsp.idsas.configuration.ServiceConfiguration;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.PostConstruct;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.servlet.annotation.WebServlet;
import javax.xml.ws.BindingType;
import javax.xml.ws.soap.Addressing;

import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.HelloRequest;
import dk.sundhedsdatastyrelsen.identitetssloering._2023._06._01.HelloResponse;

import static javax.xml.ws.soap.SOAPBinding.SOAP11HTTP_BINDING;

@WebServlet(name="HelloService", urlPatterns={"/hello"})
@WebService(serviceName = "HelloWorldService", wsdlLocation = "wsdl/hello.wsdl",
        targetNamespace = "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
        portName = "HelloWorldPort")
@BindingType(value = SOAP11HTTP_BINDING)
@Addressing(enabled = true, required = false)
public class HelloWS extends AbstractWS {

    private static final Logger logger = Logger.getLogger(HelloWS.class);

    @Autowired
    private ServiceConfiguration serviceConfiguration;

    @PostConstruct
    public void init() {
        super.init(); // Enable auto wiring!
        logger.info("init hello ws");
    }

    @WebMethod(operationName = "SayHello")
    public HelloResponse sayHello(HelloRequest request) {
        final HelloResponse response = new HelloResponse();
        response.setGreeting(serviceConfiguration.foobar + " " + request.getMyName());
        return response;
    }
}
